package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.importantevent.ImportantEventDTO;
import cn.com.tenlion.systembase.pojo.vos.importantevent.ImportantEventVO;
import cn.com.tenlion.systembase.service.importantevent.IImportantEventService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0018 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IImportantEventService importantEventService;

    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0018() {}

    @KafkaListener(topics = "C0018FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<ImportantEventDTO> importantEventDTOList = importantEventService.list(params);
        System.out.println(importantEventDTOList.size());
        if(null != importantEventDTOList && importantEventDTOList.size() > 0) {
            for(ImportantEventDTO importantEventDTO: importantEventDTOList) {
                ImportantEventVO importantEventVO = setData(importantEventDTO);
                importantEventService.saveKafka(importantEventDTO.getImportantEventId(), importantEventVO);
            }
        }
    }

    @KafkaListener(topics = "C0018")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            ImportantEventDTO importantEventDTO = importantEventService.get(jsonObject.getString("uid"));
            ImportantEventVO importantEventVO = setData(importantEventDTO);
            importantEventService.saveKafka(importantEventDTO.getImportantEventId(), importantEventVO);
        }else {
            importantEventService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private ImportantEventVO setData(ImportantEventDTO importantEventDTO) {
        if(null == importantEventDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        ImportantEventVO importantEventVO = new ImportantEventVO();
        importantEventVO.setEventName(importantEventDTO.getEventName());
        importantEventVO.setEventDate(importantEventDTO.getEventDate());
        importantEventVO.setEventSite(importantEventDTO.getEventSite());
        importantEventVO.setEventLevelText(importantEventDTO.getEventLevelText());
        importantEventVO.setEventTypeText(importantEventDTO.getEventTypeText());
        importantEventVO.setLocationCode(importantEventDTO.getLocationCode());
        importantEventVO.setLongitude(importantEventDTO.getLongitude());
        importantEventVO.setLatitude(importantEventDTO.getLatitude());
        importantEventVO.setGrid(importantEventDTO.getGrid());
        return importantEventVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}